# coding: utf-8

"""
    OpenBoxes API specification

    [OpenBoxes](https://openboxes.org) is an open-source LMIS application that increases stock visibility, reduces the risk of stock-outs and stock wastage, and offers tools to improve forecasting and traceability.  **Notice** The following API documentation is a work in progress.  ---   # noqa: E501

    OpenAPI spec version: 0.8.17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ProductAvailability(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'product': 'Product',
        'location': 'Location',
        'bin_location': 'Location',
        'inventory_item': 'InventoryItem',
        'product_code': 'str',
        'lot_number': 'str',
        'bin_location_name': 'str',
        'quantity_on_hand': 'int',
        'quantity_allocated': 'int',
        'date_created': 'datetime',
        'last_updated': 'datetime'
    }

    attribute_map = {
        'id': 'id',
        'product': 'product',
        'location': 'location',
        'bin_location': 'binLocation',
        'inventory_item': 'inventoryItem',
        'product_code': 'productCode',
        'lot_number': 'lotNumber',
        'bin_location_name': 'binLocationName',
        'quantity_on_hand': 'quantityOnHand',
        'quantity_allocated': 'quantityAllocated',
        'date_created': 'dateCreated',
        'last_updated': 'lastUpdated'
    }

    def __init__(self, id=None, product=None, location=None, bin_location=None, inventory_item=None, product_code=None, lot_number=None, bin_location_name=None, quantity_on_hand=None, quantity_allocated=None, date_created=None, last_updated=None):  # noqa: E501
        """ProductAvailability - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._product = None
        self._location = None
        self._bin_location = None
        self._inventory_item = None
        self._product_code = None
        self._lot_number = None
        self._bin_location_name = None
        self._quantity_on_hand = None
        self._quantity_allocated = None
        self._date_created = None
        self._last_updated = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if product is not None:
            self.product = product
        if location is not None:
            self.location = location
        if bin_location is not None:
            self.bin_location = bin_location
        if inventory_item is not None:
            self.inventory_item = inventory_item
        if product_code is not None:
            self.product_code = product_code
        if lot_number is not None:
            self.lot_number = lot_number
        if bin_location_name is not None:
            self.bin_location_name = bin_location_name
        if quantity_on_hand is not None:
            self.quantity_on_hand = quantity_on_hand
        if quantity_allocated is not None:
            self.quantity_allocated = quantity_allocated
        if date_created is not None:
            self.date_created = date_created
        if last_updated is not None:
            self.last_updated = last_updated

    @property
    def id(self):
        """Gets the id of this ProductAvailability.  # noqa: E501


        :return: The id of this ProductAvailability.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ProductAvailability.


        :param id: The id of this ProductAvailability.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def product(self):
        """Gets the product of this ProductAvailability.  # noqa: E501


        :return: The product of this ProductAvailability.  # noqa: E501
        :rtype: Product
        """
        return self._product

    @product.setter
    def product(self, product):
        """Sets the product of this ProductAvailability.


        :param product: The product of this ProductAvailability.  # noqa: E501
        :type: Product
        """

        self._product = product

    @property
    def location(self):
        """Gets the location of this ProductAvailability.  # noqa: E501


        :return: The location of this ProductAvailability.  # noqa: E501
        :rtype: Location
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this ProductAvailability.


        :param location: The location of this ProductAvailability.  # noqa: E501
        :type: Location
        """

        self._location = location

    @property
    def bin_location(self):
        """Gets the bin_location of this ProductAvailability.  # noqa: E501


        :return: The bin_location of this ProductAvailability.  # noqa: E501
        :rtype: Location
        """
        return self._bin_location

    @bin_location.setter
    def bin_location(self, bin_location):
        """Sets the bin_location of this ProductAvailability.


        :param bin_location: The bin_location of this ProductAvailability.  # noqa: E501
        :type: Location
        """

        self._bin_location = bin_location

    @property
    def inventory_item(self):
        """Gets the inventory_item of this ProductAvailability.  # noqa: E501


        :return: The inventory_item of this ProductAvailability.  # noqa: E501
        :rtype: InventoryItem
        """
        return self._inventory_item

    @inventory_item.setter
    def inventory_item(self, inventory_item):
        """Sets the inventory_item of this ProductAvailability.


        :param inventory_item: The inventory_item of this ProductAvailability.  # noqa: E501
        :type: InventoryItem
        """

        self._inventory_item = inventory_item

    @property
    def product_code(self):
        """Gets the product_code of this ProductAvailability.  # noqa: E501


        :return: The product_code of this ProductAvailability.  # noqa: E501
        :rtype: str
        """
        return self._product_code

    @product_code.setter
    def product_code(self, product_code):
        """Sets the product_code of this ProductAvailability.


        :param product_code: The product_code of this ProductAvailability.  # noqa: E501
        :type: str
        """

        self._product_code = product_code

    @property
    def lot_number(self):
        """Gets the lot_number of this ProductAvailability.  # noqa: E501


        :return: The lot_number of this ProductAvailability.  # noqa: E501
        :rtype: str
        """
        return self._lot_number

    @lot_number.setter
    def lot_number(self, lot_number):
        """Sets the lot_number of this ProductAvailability.


        :param lot_number: The lot_number of this ProductAvailability.  # noqa: E501
        :type: str
        """

        self._lot_number = lot_number

    @property
    def bin_location_name(self):
        """Gets the bin_location_name of this ProductAvailability.  # noqa: E501


        :return: The bin_location_name of this ProductAvailability.  # noqa: E501
        :rtype: str
        """
        return self._bin_location_name

    @bin_location_name.setter
    def bin_location_name(self, bin_location_name):
        """Sets the bin_location_name of this ProductAvailability.


        :param bin_location_name: The bin_location_name of this ProductAvailability.  # noqa: E501
        :type: str
        """

        self._bin_location_name = bin_location_name

    @property
    def quantity_on_hand(self):
        """Gets the quantity_on_hand of this ProductAvailability.  # noqa: E501


        :return: The quantity_on_hand of this ProductAvailability.  # noqa: E501
        :rtype: int
        """
        return self._quantity_on_hand

    @quantity_on_hand.setter
    def quantity_on_hand(self, quantity_on_hand):
        """Sets the quantity_on_hand of this ProductAvailability.


        :param quantity_on_hand: The quantity_on_hand of this ProductAvailability.  # noqa: E501
        :type: int
        """

        self._quantity_on_hand = quantity_on_hand

    @property
    def quantity_allocated(self):
        """Gets the quantity_allocated of this ProductAvailability.  # noqa: E501


        :return: The quantity_allocated of this ProductAvailability.  # noqa: E501
        :rtype: int
        """
        return self._quantity_allocated

    @quantity_allocated.setter
    def quantity_allocated(self, quantity_allocated):
        """Sets the quantity_allocated of this ProductAvailability.


        :param quantity_allocated: The quantity_allocated of this ProductAvailability.  # noqa: E501
        :type: int
        """

        self._quantity_allocated = quantity_allocated

    @property
    def date_created(self):
        """Gets the date_created of this ProductAvailability.  # noqa: E501


        :return: The date_created of this ProductAvailability.  # noqa: E501
        :rtype: datetime
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created):
        """Sets the date_created of this ProductAvailability.


        :param date_created: The date_created of this ProductAvailability.  # noqa: E501
        :type: datetime
        """

        self._date_created = date_created

    @property
    def last_updated(self):
        """Gets the last_updated of this ProductAvailability.  # noqa: E501


        :return: The last_updated of this ProductAvailability.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this ProductAvailability.


        :param last_updated: The last_updated of this ProductAvailability.  # noqa: E501
        :type: datetime
        """

        self._last_updated = last_updated

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProductAvailability, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProductAvailability):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
