# coding: utf-8

"""
    OpenBoxes API specification

    [OpenBoxes](https://openboxes.org) is an open-source LMIS application that increases stock visibility, reduces the risk of stock-outs and stock wastage, and offers tools to improve forecasting and traceability.  **Notice** The following API documentation is a work in progress.  ---   # noqa: E501

    OpenAPI spec version: 0.8.17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ProductCatalogItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'product': 'Product',
        'active': 'bool',
        'date_created': 'datetime',
        'last_updated': 'datetime',
        'product_catalog': 'ProductCatalog'
    }

    attribute_map = {
        'id': 'id',
        'product': 'product',
        'active': 'active',
        'date_created': 'dateCreated',
        'last_updated': 'lastUpdated',
        'product_catalog': 'productCatalog'
    }

    def __init__(self, id=None, product=None, active=None, date_created=None, last_updated=None, product_catalog=None):  # noqa: E501
        """ProductCatalogItem - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._product = None
        self._active = None
        self._date_created = None
        self._last_updated = None
        self._product_catalog = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if product is not None:
            self.product = product
        if active is not None:
            self.active = active
        if date_created is not None:
            self.date_created = date_created
        if last_updated is not None:
            self.last_updated = last_updated
        if product_catalog is not None:
            self.product_catalog = product_catalog

    @property
    def id(self):
        """Gets the id of this ProductCatalogItem.  # noqa: E501


        :return: The id of this ProductCatalogItem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ProductCatalogItem.


        :param id: The id of this ProductCatalogItem.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def product(self):
        """Gets the product of this ProductCatalogItem.  # noqa: E501


        :return: The product of this ProductCatalogItem.  # noqa: E501
        :rtype: Product
        """
        return self._product

    @product.setter
    def product(self, product):
        """Sets the product of this ProductCatalogItem.


        :param product: The product of this ProductCatalogItem.  # noqa: E501
        :type: Product
        """

        self._product = product

    @property
    def active(self):
        """Gets the active of this ProductCatalogItem.  # noqa: E501


        :return: The active of this ProductCatalogItem.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this ProductCatalogItem.


        :param active: The active of this ProductCatalogItem.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def date_created(self):
        """Gets the date_created of this ProductCatalogItem.  # noqa: E501


        :return: The date_created of this ProductCatalogItem.  # noqa: E501
        :rtype: datetime
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created):
        """Sets the date_created of this ProductCatalogItem.


        :param date_created: The date_created of this ProductCatalogItem.  # noqa: E501
        :type: datetime
        """

        self._date_created = date_created

    @property
    def last_updated(self):
        """Gets the last_updated of this ProductCatalogItem.  # noqa: E501


        :return: The last_updated of this ProductCatalogItem.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this ProductCatalogItem.


        :param last_updated: The last_updated of this ProductCatalogItem.  # noqa: E501
        :type: datetime
        """

        self._last_updated = last_updated

    @property
    def product_catalog(self):
        """Gets the product_catalog of this ProductCatalogItem.  # noqa: E501


        :return: The product_catalog of this ProductCatalogItem.  # noqa: E501
        :rtype: ProductCatalog
        """
        return self._product_catalog

    @product_catalog.setter
    def product_catalog(self, product_catalog):
        """Sets the product_catalog of this ProductCatalogItem.


        :param product_catalog: The product_catalog of this ProductCatalogItem.  # noqa: E501
        :type: ProductCatalog
        """

        self._product_catalog = product_catalog

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProductCatalogItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProductCatalogItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
