# coding: utf-8

"""
    OpenBoxes API specification

    [OpenBoxes](https://openboxes.org) is an open-source LMIS application that increases stock visibility, reduces the risk of stock-outs and stock wastage, and offers tools to improve forecasting and traceability.  **Notice** The following API documentation is a work in progress.  ---   # noqa: E501

    OpenAPI spec version: 0.8.17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UnitOfMeasureClass(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'code': 'str',
        'description': 'str',
        'active': 'bool',
        'type': 'str',
        'base_uom': 'UnitOfMeasure',
        'date_created': 'datetime',
        'last_updated': 'datetime',
        'created_by': 'User',
        'updated_by': 'User'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'code': 'code',
        'description': 'description',
        'active': 'active',
        'type': 'type',
        'base_uom': 'baseUom',
        'date_created': 'dateCreated',
        'last_updated': 'lastUpdated',
        'created_by': 'createdBy',
        'updated_by': 'updatedBy'
    }

    def __init__(self, id=None, name=None, code=None, description=None, active=None, type=None, base_uom=None, date_created=None, last_updated=None, created_by=None, updated_by=None):  # noqa: E501
        """UnitOfMeasureClass - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._code = None
        self._description = None
        self._active = None
        self._type = None
        self._base_uom = None
        self._date_created = None
        self._last_updated = None
        self._created_by = None
        self._updated_by = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if code is not None:
            self.code = code
        if description is not None:
            self.description = description
        if active is not None:
            self.active = active
        if type is not None:
            self.type = type
        if base_uom is not None:
            self.base_uom = base_uom
        if date_created is not None:
            self.date_created = date_created
        if last_updated is not None:
            self.last_updated = last_updated
        if created_by is not None:
            self.created_by = created_by
        if updated_by is not None:
            self.updated_by = updated_by

    @property
    def id(self):
        """Gets the id of this UnitOfMeasureClass.  # noqa: E501


        :return: The id of this UnitOfMeasureClass.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UnitOfMeasureClass.


        :param id: The id of this UnitOfMeasureClass.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this UnitOfMeasureClass.  # noqa: E501


        :return: The name of this UnitOfMeasureClass.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UnitOfMeasureClass.


        :param name: The name of this UnitOfMeasureClass.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def code(self):
        """Gets the code of this UnitOfMeasureClass.  # noqa: E501


        :return: The code of this UnitOfMeasureClass.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this UnitOfMeasureClass.


        :param code: The code of this UnitOfMeasureClass.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def description(self):
        """Gets the description of this UnitOfMeasureClass.  # noqa: E501


        :return: The description of this UnitOfMeasureClass.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UnitOfMeasureClass.


        :param description: The description of this UnitOfMeasureClass.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def active(self):
        """Gets the active of this UnitOfMeasureClass.  # noqa: E501


        :return: The active of this UnitOfMeasureClass.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this UnitOfMeasureClass.


        :param active: The active of this UnitOfMeasureClass.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def type(self):
        """Gets the type of this UnitOfMeasureClass.  # noqa: E501


        :return: The type of this UnitOfMeasureClass.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this UnitOfMeasureClass.


        :param type: The type of this UnitOfMeasureClass.  # noqa: E501
        :type: str
        """
        allowed_values = ["AREA", "CURRENCY", "LENGTH", "MASS", "PACKAGE", "QUANTITY", "VOLUME"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def base_uom(self):
        """Gets the base_uom of this UnitOfMeasureClass.  # noqa: E501


        :return: The base_uom of this UnitOfMeasureClass.  # noqa: E501
        :rtype: UnitOfMeasure
        """
        return self._base_uom

    @base_uom.setter
    def base_uom(self, base_uom):
        """Sets the base_uom of this UnitOfMeasureClass.


        :param base_uom: The base_uom of this UnitOfMeasureClass.  # noqa: E501
        :type: UnitOfMeasure
        """

        self._base_uom = base_uom

    @property
    def date_created(self):
        """Gets the date_created of this UnitOfMeasureClass.  # noqa: E501


        :return: The date_created of this UnitOfMeasureClass.  # noqa: E501
        :rtype: datetime
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created):
        """Sets the date_created of this UnitOfMeasureClass.


        :param date_created: The date_created of this UnitOfMeasureClass.  # noqa: E501
        :type: datetime
        """

        self._date_created = date_created

    @property
    def last_updated(self):
        """Gets the last_updated of this UnitOfMeasureClass.  # noqa: E501


        :return: The last_updated of this UnitOfMeasureClass.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this UnitOfMeasureClass.


        :param last_updated: The last_updated of this UnitOfMeasureClass.  # noqa: E501
        :type: datetime
        """

        self._last_updated = last_updated

    @property
    def created_by(self):
        """Gets the created_by of this UnitOfMeasureClass.  # noqa: E501


        :return: The created_by of this UnitOfMeasureClass.  # noqa: E501
        :rtype: User
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this UnitOfMeasureClass.


        :param created_by: The created_by of this UnitOfMeasureClass.  # noqa: E501
        :type: User
        """

        self._created_by = created_by

    @property
    def updated_by(self):
        """Gets the updated_by of this UnitOfMeasureClass.  # noqa: E501


        :return: The updated_by of this UnitOfMeasureClass.  # noqa: E501
        :rtype: User
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this UnitOfMeasureClass.


        :param updated_by: The updated_by of this UnitOfMeasureClass.  # noqa: E501
        :type: User
        """

        self._updated_by = updated_by

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UnitOfMeasureClass, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UnitOfMeasureClass):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
